package nc.ui.pu.m25.editor.card.afteredit.header;

import java.util.ArrayList;
import java.util.List;

import nc.bs.framework.common.NCLocator;
import nc.itf.pu.pub.IPURemoteCallCombinator;
import nc.itf.scmpub.reference.uap.bd.supplier.SupplierPubService;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.pu.m25.editor.utils.CurrencyUtil;
import nc.ui.pu.m25.editor.utils.ExchangeRateUtil;
import nc.ui.pu.m25.rule.InvoiceQueryPriceHandler;
import nc.ui.pu.m25.rule.InvoiceTaxEditHandler;
import nc.ui.pu.pub.editor.CardEditorHelper;
import nc.ui.pu.pub.editor.card.handler.SupplierValueHandler;
import nc.ui.pu.pub.editor.card.listener.ICardHeadTailAfterEditEventListener;
import nc.ui.pu.pub.util.SupplierFreeCustInfoUtil;
import nc.ui.pubapp.uif2app.event.card.CardHeadTailAfterEditEvent;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.jcom.lang.StringUtil;
import nc.vo.pu.m25.entity.InvoiceHeaderVO;
import nc.vo.pu.m25.pub.InvoiceVOUtil;
import nc.vo.pu.m25.rule.maintain.InvoiceSupplierVatCodeFillRule;
import nc.vo.pu.m25.rule.maintain.InvoiceVatTaxFillRule;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.data.ValueUtils;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

import org.apache.commons.lang.StringUtils;

/**
 * <b>Ҫ¹ܣӦ </b>
 * <ul>
 * <li>ͷӦ̱༭
 * </ul>
 * <p>
 * </p>
 * 
 * @author xiebo
 * @version 6.0
 * @see
 * @since
 * @time 2010-2-25 10:25:16
 */
public class Supplier implements ICardHeadTailAfterEditEventListener {
  /** һЩĺϲù */
  private List<IPURemoteCallCombinator> rccRuleLst =
      new ArrayList<IPURemoteCallCombinator>();
  public IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
  @Override
  public void afterEdit(CardHeadTailAfterEditEvent event) {
    String newValue = ValueUtils.getString(event.getValue());
    // 1.չӦʱ
    if (StringUtil.isEmptyWithTrim(newValue)) {
      // 
      // event.getBillCardPanel().setHeadItem(InvoiceHeaderVO.CORIGCURRENCYID,
      // null);
      // ոЭ
      event.getBillCardPanel().setHeadItem(InvoiceHeaderVO.PK_PAYTERM, null);
      event.getBillCardPanel().setHeadItem(InvoiceHeaderVO.PK_BANKACCBAS, null);
      event.getBillCardPanel().setHeadItem(InvoiceHeaderVO.VBANKACCOUNT, null);
      return;
    }
    // ====== Ӧ̲ ================
    // 1. ȡӦֲ̱赽ͷ(ѯ) 
    // 2. ıͷʣ¼ 
    // 3. 绰ʽʵ֣
    // 4. ˻ ʽʵ֣
    // 5. Э顢λ 
    // 6. żҵԱ 
    // 7. ɢ 
    // 8.VATϢá
    // 9.ѯۡ

    // ÷
    this.setSendcountry(event);
    SupplierValueHandler handler =
        new SupplierValueHandler(event.getBillCardPanel());
    // øλЭ飬ɹţɹԱ
    handler.handleHeadDefaultValue();
    CardEditorHelper util = new CardEditorHelper(event.getBillCardPanel());
    String oldExchangeRate =
        util.getHeadStringValue(InvoiceHeaderVO.NEXCHANGERATE);
    // ñͷ
    CurrencyUtil.setOrigcurrency(util);
    // ñͷ
    ExchangeRateUtil.setExchangerate(util);
    // ʱ仯
    ExchangeRateUtil.calculateBodyRows(util, oldExchangeRate);

    // עᣭѯ,ԱУԶ̵úϲ
    InvoiceQueryPriceHandler price =
        new InvoiceQueryPriceHandler(event.getBillCardPanel());
    price.prepareQueryPrice();

    // ע-VATȡ˰ϲ
    this.register_vattaxrule(util);

    // ע-ɢĿɱ༭Լ˺źϲ
    SupplierFreeCustInfoUtil scutil = new SupplierFreeCustInfoUtil();
    scutil.registerCombineRemoteCall(util);

    // ɢĿɱ༭Լ˺
    scutil.setFreeCustBankAcc(util);
    // ִԶ̵õĺϲ
    this.doRmtCombCallRule();
    // ִѯ
    price.handleQueryPrice();
    
    //Ƚϱ۷˾
    String str = "һ";
    try {
    	int count=event.getBillCardPanel().getRowCount();
        for(int i=0;i<count;i++){
        	String headSupplier = (String) event.getBillCardPanel().getHeadItem("pk_supplier").getValueObject();//Ӧ
        	String vbdef15 = (String) event.getBillCardPanel().getBodyValueAt(i, "vbdef15"); 
        	String vbdef20 = (String) event.getBillCardPanel().getBodyValueAt(i, "vbdef20"); 
        	if(vbdef20 == null) {
        		continue;
        	}
    		if(vbdef15 == null && headSupplier == null) {
    			//һ
    			event.getBillCardPanel().setBodyValueAt("һ", i, "vbdef14");
    		}else if(vbdef15 == null || headSupplier == null) {
    			//һ
    			event.getBillCardPanel().setBodyValueAt("һ", i, "vbdef14");
    		}else {
    			String sql = "select name from bd_supplier where pk_supplier ='"+headSupplier+"'";
    			String name = (String) iuap.executeQuery(sql, new ColumnProcessor());
    			// ʹʽ滻ΪӢ
				name = name.replaceAll("", "(").replaceAll("", ")");
				vbdef15 = vbdef15.replaceAll("", "(").replaceAll("", ")");
    			if(vbdef15.equals(name)) {
    				//һ
    				event.getBillCardPanel().setBodyValueAt("һ", i, "vbdef14");
    			}else {
    				//һ
    				event.getBillCardPanel().setBodyValueAt("һ", i, "vbdef14");
    			}
    		}
        }
	} catch (Exception e) {
		ExceptionUtils.wrappBusinessException(e.getMessage());
	}
    
  }

  private void doRmtCombCallRule() {
    try {
      for (IPURemoteCallCombinator rccrule : this.rccRuleLst) {
        rccrule.process();
      }
    }
    catch (Exception e) {
      ExceptionUtils.wrappException(e);
    }
    finally {
      // ɺ
      this.rccRuleLst.clear();
    }
  }

  private void register_vattaxrule(CardEditorHelper invoice) {
    // չӦVATע
    invoice.setHeadValue(InvoiceHeaderVO.VVENDORVATCODE, null);

    IPURemoteCallCombinator vattaxrule =
        new InvoiceTaxEditHandler(invoice.getEditor(), null,
            new InvoiceSupplierVatCodeFillRule(new CardEditorHelper[] {
              invoice
            }), new InvoiceVatTaxFillRule(new CardEditorHelper[] {
              invoice
            }));
    vattaxrule.prepare();
    this.rccRuleLst.add(vattaxrule);
  }

  private boolean setSendcountry(CardHeadTailAfterEditEvent event) {
    CardEditorHelper invoice = new CardEditorHelper(event.getBillCardPanel());
    String pk_supplier = (String) event.getValue();
    // ƵķƱ޸Ĺ
    if (StringUtils.isBlank(pk_supplier) || !InvoiceVOUtil.isSelfMade(invoice)) {
      return false;
    }
    // л棬ﲻԶ̵
    String pk_country = SupplierPubService.queryCountryBySupplier(new String[] {
      pk_supplier
    }).get(pk_supplier);
    String old_country =
        invoice.getHeadStringValue(InvoiceHeaderVO.CSENDCOUNTRYID);
    if (StringUtils.isBlank(pk_country) || pk_country.equals(old_country)) {
      return false;
    }
    invoice.setHeadValue(InvoiceHeaderVO.CSENDCOUNTRYID, pk_country);
    return true;
  }
}
