/**
 * $ļ˵$
 * 
 * @author zhaoyha
 * @version 6.0
 * @see
 * @since 6.0
 * @time 2010-2-26 10:59:05
 */
package nc.impl.pu.m25.action;

import nc.bs.ic.base.InvoiceAfterCheckEvent;
import nc.bs.pu.m25.maintain.InvoiceSaveBP;
import nc.bs.pu.m25.plugin.InvoicePluginPoint;
import nc.impl.pubapp.pattern.data.bill.tool.BillTransferTool;
import nc.impl.pubapp.pattern.rule.processer.CompareAroundProcesser;
import nc.vo.pu.m25.entity.InvoiceItemVO;
import nc.vo.pu.m25.entity.InvoiceVO;
import nc.vo.pu.m25.env.InvoiceUIToBSEnv;
import nc.vo.pu.m25.rule.ParaValidityChkRule;

/**
 * <p>
 * <b>Ҫ¹ܣ</b>
 * <ul>
 * <li>Ʊ޸Ķ
 * </ul>
 * <p>
 * <p>
 * 
 * @version 6.0
 * @since 6.0
 * @author zhaoyha
 * @time 2010-2-26 10:59:05
 */
public class InvoiceUpdateAction {

  public InvoiceVO[] update(InvoiceVO[] invoiceVOs, InvoiceUIToBSEnv env) {
    InvoiceVO[] vos = invoiceVOs;
    //Ƿһݴ
    //2023-07-2 
    String str = "һ";
    Boolean boo = false;
    InvoiceItemVO[] invoiceItems = vos[0].getChildrenVO();
    for (int i = 0; i < invoiceItems.length; i++) {
    	InvoiceItemVO invoiceItemVO = invoiceItems[i];
    	String vbdef14 = invoiceItemVO.getVbdef14();
    	String vbdef20 = invoiceItemVO.getVbdef20();
    	
    	if("һ".equals(vbdef14)) {
    		str = "һ";
    	}
    	if(vbdef20 != null) {
    		boo = true;
    	}
	}
    if(boo) {
		 vos[0].getParentVO().setVdef18(str);
	}
    vos[0].getParentVO().setVdef18(str);
    BillTransferTool<InvoiceVO> tool = new BillTransferTool<InvoiceVO>(vos);
    InvoiceVO[] orgVos = tool.getOriginBills();
    // v61 ЭӿڵߴһȫVO
    // vos = tool.getClientFullInfoBill(); // ǰ̨޸Ĺ,ﲹΪVO
    CompareAroundProcesser<InvoiceVO> processer =
        new CompareAroundProcesser<InvoiceVO>(InvoicePluginPoint.UI_UPDATE);
    this.addRule(processer);
    processer.before(vos, orgVos);
    InvoiceVO[] savedVos = new InvoiceSaveBP(env).save(null, vos, orgVos);
    processer.after(savedVos, orgVos);
    return savedVos;
  }

  private void addRule(CompareAroundProcesser<InvoiceVO> processer) {
    processer.addBeforeFinalRule(new ParaValidityChkRule());// ȷԼ
    processer.addAfterFinalRule(new InvoiceAfterCheckEvent());
    // processer.addAfterRule(new WriteSysLogRule());// дϵͳ־
  }

}
