package nc.ui.pu.m25.editor.card.afteredit.body;

import java.util.Arrays;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.ui.pu.pub.editor.card.listener.ICardBodyAfterEditEventListener;
import nc.ui.pub.beans.UIRefPane;
import nc.ui.pub.beans.constenum.DefaultConstEnum;
import nc.ui.pubapp.uif2app.event.card.CardBodyAfterEditEvent;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public class OcrRefaft implements ICardBodyAfterEditEventListener{
	
	public IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	@Override
	public void afterEdit(CardBodyAfterEditEvent arg0) {
		try {
			UIRefPane ref = (UIRefPane) arg0.getBillCardPanel().getBodyItem("OCR").getComponent();
			String[] pks = ref.getRefPKs();
			StringBuffer sbf = new StringBuffer();
			// PK
			if (pks == null || pks.length <= 0) {
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "vbdef15");//۷˾
			    arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "vbdef17");//Ʊ
			    arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "ntaxrate");//˰
		 	    arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "ctaxcodeid");//˰
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "nastnum");//
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "nnum");//
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "nastorigprice");//˰
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "nastprice");//˰
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "nprice");//˰
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "norigmny");//˰
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "nmny");//˰
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "nastorigtaxprice");//˰
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "nasttaxprice");//Һ˰
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "ntaxprice");//Һ˰
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "norigtaxmny");//˰ϼ
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "ntaxmny");//Ҽ˰ϼ
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "ntax");//˰
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "vbdef20");//
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "vbdef16");//ʾ
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "ncalcostmny");//Ƴɱ
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "vbdef13");//Ʊ
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "vbdef14");//Ƿһ
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "vbdef12");//ʾ
				arg0.getBillCardPanel().setBodyValueAt(null, arg0.getRow(), "vbdef11");//Ʊַ
				return;
			}else {
				for (int i = 0; i < pks.length; i++) {
					sbf.append(pks[i]+",");
				}	
			}
			
			
			UFDouble SumAmount = UFDouble.ZERO_DBL;//˰
			UFDouble SumTotal = UFDouble.ZERO_DBL;//˰ϼ
			UFDouble SumTax =UFDouble.ZERO_DBL;//˰
			String url = null;
			String shuilv = "";//¼һ˰ʣͺжԱȣͬ򱨴
			String supplier = "";//¼һӦ̣ͺжԱȣͬ򱨴
			Object shuilvpk = "";
			StringBuffer kind = new StringBuffer();
			if(pks.length > 1){
				for(int j = 0;j < pks.length;j++){
					String pk = pks[j];
					String qrysql = "select * from bd_defdoc where dr=0 and pk_defdoc = '"+pk+"'";
					DefdocVO defdocvo;
					defdocvo = (DefdocVO) iuap.executeQuery(qrysql, new BeanProcessor(DefdocVO.class));
					Object shortname6 = defdocvo.getShortname6();
					String name4 = defdocvo.getName4();
					if(shortname6 == null){
						ExceptionUtils.wrappBusinessException("ѡƱ˰Ϊգܱ棡");
						return;
					}
					if(j == 0 && shortname6 != null){
						shuilv = shortname6.toString();
					}
					if(j == 0 || supplier == null){
						supplier = name4;
					}
					if(j != 0 && !shortname6.toString().equals(shuilv)){
						ExceptionUtils.wrappBusinessException("ѡƱ˰ʲܱͬ棡");
						return;
					}
					if(j != 0 && name4 != null && supplier != null) {
						if(!name4.equals(supplier)) {
							ExceptionUtils.wrappBusinessException("ѡƱӦ̲ܱͬ棡");
							return;
						}
					}
				}
			}
			//һѡŷƱˣѭûͲĶԭ򣬲
			for(int i = 0;i < pks.length;i++){
				String pk = pks[i];
				String qrysql = "select * from bd_defdoc where dr=0 and pk_defdoc = '"+pk+"'";
				DefdocVO defdocvo;
				
					defdocvo = (DefdocVO) iuap.executeQuery(qrysql, new BeanProcessor(DefdocVO.class));
					String qryshuilv = "select pk_taxcode from bd_taxrate where nvl(dr,0) = 0 and pk_taxcode not in (select pk_taxcode from bd_taxcode where code = '0') and taxrate = '"+defdocvo.getShortname6()+"'";
					try {
						shuilvpk = iuap.executeQuery(qryshuilv, new ColumnProcessor());
						if(shuilvpk == null){
							ExceptionUtils.wrappBusinessException("˰ûжӦ˰룬飡");
							return;
						}
					} catch (BusinessException e1) {
						// TODO Զɵ catch 
						ExceptionUtils.wrappBusinessException(e1.getMessage());
					}
					arg0.getBillCardPanel().setBodyValueAt(defdocvo.getName4(), arg0.getRow(), "vbdef15");//۷˾
					arg0.getBillCardPanel().setBodyValueAt(defdocvo.getShortname5(), arg0.getRow(), "vbdef17");//Ʊ
					arg0.getBillCardPanel().setBodyValueAt(defdocvo.getShortname6(), arg0.getRow(), "ntaxrate");//˰
					arg0.getBillCardPanel().setBodyValueAt(shuilvpk, arg0.getRow(), "ctaxcodeid");//˰
					arg0.getBillCardPanel().setBodyValueAt(defdocvo.getCode(), arg0.getRow(), "vbdef16");//Ʊfid
					
					StringBuffer sql = new StringBuffer();
					sql.append("SELECT");
					sql.append(" * ");
					sql.append(" FROM");
					sql.append(" ocr_defdoc");
					sql.append(" WHERE");
					sql.append(" vdef17 = '"+defdocvo.getName6()+"' ");
					sql.append(" AND numberid = '"+defdocvo.getCode()+"' ");
					Map<String,String> mapdb = (Map<String, String>) iuap.executeQuery(sql.toString(), new MapProcessor());
					//ΪnullʾΪƱϴݣαʾΪƱƻȡ
					//ƱϴݿֱʹáƱƻȡĿܴڶʹãȡм
					if(mapdb.get("kyhsje") == null) {
						Object shortname = defdocvo.getShortname();
						if(shortname != null && shortname.toString() != ""){
							SumAmount = SumAmount.add(new UFDouble(shortname.toString()));
						}
						Object shortname2 = defdocvo.getShortname2();
						if(shortname2 != null && shortname2.toString() != ""){
							SumTotal = SumTotal.add(new UFDouble(shortname2.toString()));
						}
						Object shortname3 = defdocvo.getShortname3();
						if(shortname3 != null && shortname3.toString() != ""){
							SumTax = SumTax.add(new UFDouble(shortname3.toString()));
						}
					}else {
						SumAmount = SumAmount.add(new UFDouble(mapdb.get("kywsje")));
						SumTotal = SumTotal.add(new UFDouble(mapdb.get("kyhsje")));
						SumTax = SumTax.add(new UFDouble(mapdb.get("jyse")));
						
					}
					
					url = mapdb.get("fpxz");
					kind.append(defdocvo.getShortname4()+",");
			}
			//۷˾͹Ӧ֮УǷһ
			String vbdef15 = (String) arg0.getBillCardPanel().getBodyValueAt(arg0.getRow(), "vbdef15");//۷˾
			String headSupplier = (String) arg0.getBillCardPanel().getHeadItem("pk_supplier").getValueObject();//Ӧ
			if(vbdef15 == null && headSupplier == null) {
				//һ
				arg0.getBillCardPanel().setBodyValueAt("һ", arg0.getRow(), "vbdef14");
			}else if(vbdef15 == null || headSupplier == null) {
				//һ
				arg0.getBillCardPanel().setBodyValueAt("һ", arg0.getRow(), "vbdef14");
			}else {
				String sql = "select name from bd_supplier where pk_supplier ='"+headSupplier+"'";
				String name = (String) iuap.executeQuery(sql, new ColumnProcessor());
				// ʹʽ滻ΪӢ
				name = name.replaceAll("", "(").replaceAll("", ")");
				vbdef15 = vbdef15.replaceAll("", "(").replaceAll("", ")");
				if(vbdef15.equals(name)) {
					//һ
					arg0.getBillCardPanel().setBodyValueAt("һ", arg0.getRow(), "vbdef14");
				}else {
					//һ
					arg0.getBillCardPanel().setBodyValueAt("һ", arg0.getRow(), "vbdef14");
				}
			}
			
			//˰ϼС0
			if(SumTotal.compareTo(new UFDouble(0)) < 0) {
				arg0.getBillCardPanel().setBodyValueAt(-1, arg0.getRow(), "nastnum");//
				arg0.getBillCardPanel().setBodyValueAt(-1, arg0.getRow(), "nnum");//
				arg0.getBillCardPanel().setBodyValueAt(SumTotal.abs(), arg0.getRow(), "nastorigtaxprice");//˰
				arg0.getBillCardPanel().setBodyValueAt(SumTotal.abs(), arg0.getRow(), "nasttaxprice");//Һ˰
				arg0.getBillCardPanel().setBodyValueAt(SumTotal.abs(), arg0.getRow(), "ntaxprice");//Һ˰
				arg0.getBillCardPanel().setBodyValueAt(SumAmount.abs(), arg0.getRow(), "nastorigprice");//˰
				arg0.getBillCardPanel().setBodyValueAt(SumAmount.abs(), arg0.getRow(), "nastprice");//˰
				arg0.getBillCardPanel().setBodyValueAt(SumAmount.abs(), arg0.getRow(), "nprice");//˰
			}else {
				arg0.getBillCardPanel().setBodyValueAt(1, arg0.getRow(), "nastnum");//
				arg0.getBillCardPanel().setBodyValueAt(1, arg0.getRow(), "nnum");//
				arg0.getBillCardPanel().setBodyValueAt(SumTotal, arg0.getRow(), "nastorigtaxprice");//˰
				arg0.getBillCardPanel().setBodyValueAt(SumTotal, arg0.getRow(), "nasttaxprice");//Һ˰
				arg0.getBillCardPanel().setBodyValueAt(SumTotal, arg0.getRow(), "ntaxprice");//Һ˰
				arg0.getBillCardPanel().setBodyValueAt(SumAmount, arg0.getRow(), "nastorigprice");//˰
				arg0.getBillCardPanel().setBodyValueAt(SumAmount, arg0.getRow(), "nastprice");//˰
				arg0.getBillCardPanel().setBodyValueAt(SumAmount, arg0.getRow(), "nprice");//˰
			}
			
			arg0.getBillCardPanel().setBodyValueAt(url, arg0.getRow(), "vbdef11");//Ʊַ
			arg0.getBillCardPanel().setBodyValueAt(SumAmount, arg0.getRow(), "norigmny");//˰
			arg0.getBillCardPanel().setBodyValueAt(SumAmount, arg0.getRow(), "nmny");//˰
			arg0.getBillCardPanel().setBodyValueAt(SumAmount, arg0.getRow(), "ncalcostmny");//Ƴɱ
			arg0.getBillCardPanel().setBodyValueAt(SumTotal, arg0.getRow(), "norigtaxmny");//˰ϼ
			arg0.getBillCardPanel().setBodyValueAt(SumTotal, arg0.getRow(), "ntaxmny");//Ҽ˰ϼ
			arg0.getBillCardPanel().setBodyValueAt(SumTax, arg0.getRow(), "ntax");//˰
			
			
			
			//PK
		//	ref.setPKs(pks);
			DefaultConstEnum refEnumxz = new DefaultConstEnum(sbf.toString().substring(0, sbf.toString().length()-1), ref.getRefShowName());
			//DefaultConstEnum refEnum = new DefaultConstEnum("1001ZZ1000000097LQJ2", "ƱϢѸֵ");///ĬֵƱϢѸֵ
			//arg0.getBillCardPanel().setBodyValueAt(refEnum, arg0.getRow(), "OCR");//Ĭ
			String vbdef13 = kind.toString();
			byte[] bytes = kind.toString().getBytes("UTF-8");
			if (bytes.length > 101) {
			    byte[] truncatedBytes = Arrays.copyOf(bytes, 101);
			    vbdef13 = new String(truncatedBytes, "UTF-8");
			}
			arg0.getBillCardPanel().setBodyValueAt(vbdef13, arg0.getRow(), "vbdef13");//Ʊ
			arg0.getBillCardPanel().setBodyValueAt(sbf.toString().substring(0, sbf.toString().length()-1), arg0.getRow(), "vbdef20");//
			arg0.getBillCardPanel().setBodyValueAt(refEnumxz, arg0.getRow(), "vbdef12");//ʾ
		} catch (Exception e) {
			// TODO Զɵ catch 
			ExceptionUtils.wrappBusinessException(e.getMessage());
		}
   }

}