package nc.bs.pu.plugin.DataUtils;

import java.util.HashMap;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.bd.material.MaterialVO;
import nc.vo.ct.purdaily.entity.CtPuBVO;
import nc.vo.org.DeptVO;
import nc.vo.org.FinanceOrgVO;
import nc.vo.org.PurchaseOrgVO;
import nc.vo.pu.m25.entity.InvoiceItemVO;

public class QueryDataUtil {

	private static IUAPQueryBS iuap = (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	
	public static void getBillno(String billno)throws Exception {
		String sql = "select pk_order from po_order where vbillcode = '"+billno+"' and nvl(dr,0) = 0";
		String pk_order = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_order != null) {
			throw new Exception("ɹݺѴ!");
		}
	}
	
	// û 
	public static String getUserPK(String code) throws Exception {
		if("".equals(code)) {
			return null;
		}
		String sql = "select cuserid from sm_user where  cuserid = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String cuserid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cuserid == null) {
			throw new Exception("ȡûϢʧ,δҵ" + code + "йصݣ");
		}
		return cuserid;
	}
	
	//  
	public static String getDeptPK(String code) throws Exception {
		if("".equals(code)) {
			return null;
		}
		String sql = "select pk_dept from org_dept where  code = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String pk_dept = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_dept == null) {
			throw new Exception("ȡϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_dept;
	}
	
	// Ű汾
	public static String getDeptVPK(String code) throws Exception {
		if("".equals(code)) {
			return null;
		}
		String sql = "select pk_vid from org_dept_v where  code = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String pk_vid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_vid == null) {
			throw new Exception("ȡϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_vid;
	}	
	
	
	// Ա
	public static String getPsndocPK(String code) throws Exception {
		if("".equals(code)) {
			return null;
		}
		String sql = "select pk_psndoc from sm_user where  cuserid = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String pk_psndoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_psndoc == null) {
			throw new Exception("ȡԱϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_psndoc;
	}
	
	
	// ҵ
	public static String getBusitypePK(String code) throws Exception {
		String sql = "select pk_busitype from bd_busitype where  busicode = '"+code+"' and validity = '1' and nvl(dr,0) = 0";
		String pk_busitype = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_busitype == null) {
			throw new Exception("ȡҵϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_busitype;
	}
	
	// 
	public static String getCurrtypePK(String code) throws Exception {
		String sql = "select pk_currtype from bd_currtype where  code = '"+code+"'and nvl(dr,0) = 0";
		String pk_currtype = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_currtype == null) {
			throw new Exception("ȡϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_currtype;
	}
	//֯_ҵԪ_ɹ֯
	public static PurchaseOrgVO getFinanceOrgVO(String code) throws Exception {
		String sql = "select * from org_purchaseorg where  code = '"+code+"'and nvl(dr,0) = 0";
		PurchaseOrgVO purchaseOrgVO = (PurchaseOrgVO) iuap.executeQuery(sql, new BeanProcessor(PurchaseOrgVO.class));
		if (purchaseOrgVO == null) {
			throw new Exception("ȡ֯_ҵԪ_ɹ֯Ϣʧ,δҵ" + code + "йصݣ");
		}
		return purchaseOrgVO;
	}
	//֯_
	public static String getGroupPK(String code) throws Exception {
		String sql = "select pk_group from org_group where  code = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String pk_group = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_group == null) {
			throw new Exception("ȡ֯_Ϣʧ,δҵ" + code + "йصݣ");
		}
		return pk_group;
	}
	//
	public static String getBilltypePK(String code) throws Exception {
		if("".equals(code)) {
			return null;
		}
		String sql = "select pk_billtypeid from bd_billtype where  pk_billtypecode = '"+code+"' and nvl(dr,0) = 0";
		String pk_billtypeid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_billtypeid == null) {
			throw new Exception("ȡϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_billtypeid;
	}
	
	
	//ҵ
	public static String getCountryzonePK(String code) throws Exception {
		String sql = "select pk_country from bd_countryzone where  code  = '"+code+"' and nvl(dr,0) = 0";
		String pk_country = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_country == null) {
			throw new Exception("ȡҵϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_country;
	}
	//
	public static MaterialVO getMaterialPK(String code) throws Exception {
		if("".equals(code)) {
			return null;
		}
		String sql = "select * from bd_material where  code  = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		MaterialVO materialVO = (MaterialVO) iuap.executeQuery(sql, new BeanProcessor(MaterialVO.class));
		if (materialVO == null) {
			throw new Exception("ȡϢʧ,δҵ" + code + "йصݣ");
		}
		return materialVO;
	}
	//֧Ŀ
	public static String getInoutbusiclassPK(String code) throws Exception {
		if("".equals(code)) {
			return null;
		}
		String sql = "select pk_inoutbusiclass from bd_inoutbusiclass where  code  = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String pk_inoutbusiclass = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_inoutbusiclass == null) {
			throw new Exception("ȡ֧ĿϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_inoutbusiclass;
	}
	
	
	
	//Զ嵵
	public static String getDefdocPK(String code,String defdoclistcode,String name) throws Exception {
		if("".equals(code)) {
			return null;
		}
		String sql = "select pk_defdoc from bd_defdoc where pk_defdoclist = (select pk_defdoclist from bd_defdoclist where code = '"+defdoclistcode+"' and nvl(dr,0) = 0) and code  = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String pk_defdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_defdoc == null) {
			throw new Exception("ȡ"+name+"Ϣʧ,δҵ" + code + "йصݣ");
		}
		return pk_defdoc;
	}
	
	//Ӧ
	public static String getSupplierPK(String code) throws Exception {
		if("".equals(code)) {
			return null;
		}
		String sql = "select pk_supplier from bd_supplier where  code  = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String pk_supplier = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_supplier == null) {
			throw new Exception("ȡӦϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_supplier;
	}
	
	//˻
	public static String getBankaccsubPK(String accnum,String pk_supplier) throws Exception {
		if("".equals(accnum) || "".equals(pk_supplier)) {
			return null;
		}
		String sql = "select pk_bankaccsub  from bd_bankaccsub where accnum = '"+accnum+"' and pk_bankaccbas in(select pk_bankaccbas from bd_custbank where pk_cust = '"+pk_supplier+"') and fronzenstate  = '0'";
		String pk_bankaccsub = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_bankaccsub == null) {
			throw new Exception("ȡ˻Ϣʧ,δҵ" + accnum + "йصݣ");
		}
		return pk_bankaccsub;
	}
	
	//˻
	public static String getBankdocName(String accnum,String pk_supplier) throws Exception {
		if("".equals(accnum) || "".equals(pk_supplier)) {
			return null;
		}
		String sql = "select name from bd_bankdoc where pk_bankdoc = (select pk_bankdoc  from bd_bankaccbas where accnum = '"+accnum+"' and pk_bankaccbas in(select pk_bankaccbas from bd_custbank where pk_cust = '"+pk_supplier+"') and accstate  = 0) and enablestate = 2";
		String pk_bankaccsub = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_bankaccsub == null) {
			throw new Exception("ȡ˻Ϣʧ,δҵ" + accnum + "йصݣ");
		}
		return pk_bankaccsub;
	}	
	
	//㷽ʽ
	public static String getBalatypePK(String code) throws Exception {
		String sql = "select pk_balatype from bd_balatype where  code  = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String pk_balatype = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_balatype == null) {
			throw new Exception("ȡ㷽ʽϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_balatype;
	}
	
	//ֵ˰˰˰
	public static String getTaxcodePK(String code) throws Exception {
		String sql = "select pk_taxcode from bd_taxcode where  code  = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String pk_taxcode = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_taxcode == null) {
			throw new Exception("ȡ˰Ϣʧ,δҵ" + code + "йصݣ");
		}
		return pk_taxcode;
	}
	//ͻ
	public static String getCustomerPK(String code) throws Exception {
		if("".equals(code)) {
			return null;
		}
		String sql = "select pk_customer from bd_customer where  code  = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String pk_customer = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_customer == null) {
			throw new Exception("ȡͻϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_customer;
	}	
	
	//Ŀ
	public static String getprojectPK(String code) throws Exception {
		if("".equals(code)) {
			return null;
		}
		String sql = "select pk_project from bd_project where  project_code  = '"+code+"' and enablestate = '2' and nvl(dr,0) = 0";
		String pk_project = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_project == null) {
			throw new Exception("ȡĿϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_project;
	}
	//λ
	public static String getMeasdocPK(String code) throws Exception {
		String sql = "select pk_measdoc from bd_measdoc where code = '"+code+"'";
		String pk_measdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_measdoc == null) {
			throw new Exception("ȡλϢʧ,δҵ" + code + "йصݣ");
		}
		return pk_measdoc;
	}
		
	
	
	//ɹͬӱ
	public static CtPuBVO getContract(String vbillcode,String crowno)throws Exception {
		if("".equals(vbillcode)) {
			return null;
		}
		String sql = "select * from ct_pu_b where pk_ct_pu = (select pk_ct_pu from ct_pu where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0) and crowno = '"+crowno+"' and nvl(dr,0) = 0";
		CtPuBVO ctPuBVO = (CtPuBVO) iuap.executeQuery(sql, new BeanProcessor(CtPuBVO.class));
		if (ctPuBVO == null) {
			throw new Exception("ȡɹͬϢʧ,δҵ" + vbillcode + ","+crowno+"йصݣ");
		}
		return ctPuBVO;
	}
	
	
	//ѯԴͷԴ
	public static Map<String,String> getDataMap(String type,String vbillcode,String crowno)throws Exception {
		if("".equals(vbillcode)) {
			return null;
		}
		Map<String,String> map = new HashMap<String,String>();
		String sql = "";
		
		if("20".equals(type)) {
			sql = "select pk_praybill as pk_id,pk_praybill_b as pk_id_b from po_praybill_b where pk_praybill = (select pk_praybill from po_praybill where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0) and crowno = '"+crowno+"' and nvl(dr,0) = 0";
			map = (Map<String, String>) iuap.executeQuery(sql.toString(), new MapProcessor());
			if(map == null) {
				throw new Exception("ȡ빺Ϣʧ,δҵ" + vbillcode + ","+crowno+"йصݣ");
			}
		}else if("Z2".equals(type)) {
			sql = "select pk_ct_pu as pk_id,pk_ct_pu_b as pk_id_b from ct_pu_b where pk_ct_pu = (select pk_ct_pu from ct_pu where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0) and crowno = '"+crowno+"' and nvl(dr,0) = 0";
			map = (Map<String, String>) iuap.executeQuery(sql.toString(), new MapProcessor());
			if(map == null) {
				throw new Exception("ȡɹͬϢʧ,δҵ" + vbillcode + ","+crowno+"йصݣ");
			}
		}else if("21".equals(type)) {
			sql = "select pk_order as pk_id,pk_order_b as pk_id_b from po_order_b where pk_order = (select pk_order  from po_order where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0) and crowno = '"+crowno+"' and nvl(dr,0) = 0";
			map = (Map<String, String>) iuap.executeQuery(sql.toString(), new MapProcessor());
			if(map == null) {
				throw new Exception("ȡɹϢʧ,δҵ" + vbillcode + ","+crowno+"йصݣ");
			}
			
		}else if("45".equals(type)) {
			sql = "select cgeneralhid as pk_id,cgeneralbid as pk_id_b from ic_purchasein_b where cgeneralhid = (select cgeneralhid from vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0) and crowno = '"+crowno+"' and nvl(dr,0) = 0";
			map = (Map<String, String>) iuap.executeQuery(sql.toString(), new MapProcessor());
			if(map == null) {
				throw new Exception("ȡɹⵥϢʧ,δҵ" + vbillcode + ","+crowno+"йصݣ");
			}
		}
		return map;
	}
	
	
}
